#include "central.h"
#include "mapedit.h"
#include <allegro.h>

PALLETE pallete;

//extern int Map[1000][1000];
struct MapStruct {
   int l1;
   int l2;
} Map[100][100];

struct UserStruct {  //Map Tiles and Flags
	int tile;
   int tileOffset;
   int x;
   int y;
   int layer;
   int screenX;
   int screenY;
} User;

int KeyHandler()
{
  int quit = FALSE;
  int keye;
  int InMenu = FALSE;
  User.tile=2;
  User.x=0;
  User.y=0;
  User.tileOffset=0;
  User.screenX=0;
  User.screenY=0;
  User.layer=0;

  InitEditor();


  do
    {
      do
      {
      }
      while (!keypressed());
      keye = readkey ();
      keye = keye >> 8;
      switch(keye)
      {
      case KEY_ENTER:
         save_bitmap("editor.bmp",screen,pallete);
         break;
      case KEY_1:
         User.layer=1;
         DrawLayer1();
         ShowMap();
         DrawExtras();
         break;
      case KEY_2:
         User.layer=2;
         DrawLayer2();
         ShowMap();
         DrawExtras();
         break;
      case KEY_3:
         User.layer=0;
         DrawMap();
         ShowMap();
         DrawExtras();
         break;
      case KEY_S:
         if(key_shifts & KB_CTRL_FLAG) {
            SaveFile(); }
         else {
            Map[User.x+(User.screenX)][User.y+(User.screenY)].l2=(User.tile+User.tileOffset);
            DrawIt(); }
         break;
      case KEY_A:
         Map[User.x+(User.screenX)][User.y+(User.screenY)].l1=(User.tile+User.tileOffset);
         DrawIt();
         break;
      case KEY_L:
         if(key_shifts & KB_CTRL_FLAG) {
            LoadFile(); }
         break;
      case KEY_D:
         if(User.tile==0 && User.tileOffset!=0)
            User.tileOffset--;
         if(User.tile>0)
            User.tile--;
         DrawIt();
         break;
      case KEY_F:
         if(User.tile>18)
            User.tileOffset++;
         else
         User.tile++;
         DrawIt();
         break;
      case KEY_UP:
         if(key_shifts & KB_CTRL_FLAG) {
            if(User.screenY>4)
               User.screenY-=5;  }
         else {
            if(User.y==0) {
               if(User.screenY>0)
                  User.screenY--;  }
            else
            User.y--;  }
         DrawIt();
         break;
      case KEY_DOWN:
         if(key_shifts & KB_CTRL_FLAG) {
               User.screenY+=5;  }
         else {
            if(User.y==10) {
                  User.screenY++;  }
            else
            User.y++;  }
         DrawIt();
         break;
      case KEY_LEFT:
         if(key_shifts & KB_CTRL_FLAG) {
            if(User.screenX>4)
               User.screenX-=5;  }
         else {
            if(User.x==0) {
               if(User.screenX>0)
                  User.screenX--;  }
            else
            User.x--;  }
         DrawIt();
         break;
      case KEY_RIGHT:
         if(key_shifts & KB_CTRL_FLAG) {
               User.screenX+=5;  }
         else {
            if(User.x==19) {
                  User.screenX++;  }
            else
            User.x++;  }
           DrawIt();
           break;
      case KEY_ESC:
         quit=TRUE;
         break;
      }
   }
   while (quit != TRUE);
   return 1;
}
